type file {}

(file f1, file f2, file f3, file f4, file f5, file f6) prepare_ligand (string ligand_prefix, file ligand_input_file){
	app { 
	amberize_ligand ligand_prefix "-c" "bcc";
	}
}

(file f1, file f2, file f3, file f4) prepare_receptor (string receptor_prefix, file receptor_input_file) {
	app { 
	amberize_receptor receptor_prefix;
	}
}

(file f1, file f2, file f3, file f4) prepare_complex (string receptor_prefix, string ligand_prefix, file receptor_input_file, file ligand_input_file) {
	app { 
	amberize_complex receptor_prefix ligand_prefix;
	}
}

(file fout) run_MD_with_nab (string receptor_prefix, string ligand_prefix, string output_file_name, file f1, file f2, file f3, file f4, file f5, file f6, file f7, file f8, file f9, file f10, file f11, file f12, file f13, file f14) {
	app { 
	run_MD_for_impdh receptor_prefix ligand_prefix  output_file_name;
	}
}

string receptor_prefix = "impdh_min";

// file receptor_input_file <single_file_mapper;file=@strcat(receptor_prefix,".pdb")>;

file rec_log_file <single_file_mapper;file=@strcat(receptor_prefix,".log")>;
file rec_prmtop_file <single_file_mapper;file=@strcat(receptor_prefix,".prmtop")>;
file rec_inpcrd_file <single_file_mapper;file=@strcat(receptor_prefix,".inpcrd")>;
file rec_amber_pdb_file <single_file_mapper;file=@strcat(receptor_prefix,".amber.pdb")>;

file fls[]<filesys_mapper;pattern="rank_*.mol2",location=".">;

//(rec_prmtop_file,rec_log_file,rec_inpcrd_file,rec_amber_pdb_file) = prepare_receptor(receptor_prefix,receptor_input_file);

foreach ligand_input_file,ii in fls{

	string ligand_prefix = @strcut(@ligand_input_file,"\.\/(.*)\.mol2");
	string complex_prefix = @strcat("impdh_min.",ligand_prefix);

	file prmtop_file <single_file_mapper;file=@strcat(ligand_prefix,".prmtop")>;
	file log_file <single_file_mapper;file=@strcat(ligand_prefix,".log")>;
	file inpcrd_file <single_file_mapper;file=@strcat(ligand_prefix,".inpcrd")>;
	file frcmod_file<single_file_mapper;file=@strcat(ligand_prefix,".frcmod")>;
	file amber_pdb_file <single_file_mapper;file=@strcat(ligand_prefix,".amber.pdb")>;
	file gaff_input_file <single_file_mapper;file=@strcat(ligand_prefix,".gaff.mol2")>;

	file complex_input_file <single_file_mapper;file=@strcat(complex_prefix,".pdb")>;
	file complex_prmtop_file <single_file_mapper;file=@strcat(complex_prefix,".prmtop")>;
	file complex_log_file <single_file_mapper;file=@strcat(complex_prefix,".log")>;
	file complex_inpcrd_file <single_file_mapper;file=@strcat(complex_prefix,".inpcrd")>;
	file complex_amber_pdb_file <single_file_mapper;file=@strcat(complex_prefix,".amber.pdb")>;
        string nab_stdout_name = @strcat(ligand_prefix,".stdout");
	//string trj_file_name = @strcat(ligand_prefix,".binpos");
        file nab_stdout <single_file_mapper;file=@strcat(ligand_prefix,".stdout")>;
	//file trj_file <single_file_mapper;file=@strcat(ligand_prefix,".binpos")>;

	(prmtop_file,log_file,inpcrd_file,amber_pdb_file,gaff_input_file,frcmod_file) = prepare_ligand(ligand_prefix,ligand_input_file);
	(complex_prmtop_file,complex_log_file,complex_inpcrd_file,complex_amber_pdb_file) = prepare_complex(receptor_prefix,ligand_prefix,amber_pdb_file,rec_amber_pdb_file);
	(nab_stdout) =run_MD_with_nab(receptor_prefix,ligand_prefix,nab_stdout_name,complex_prmtop_file,complex_log_file,complex_inpcrd_file,complex_amber_pdb_file,prmtop_file,log_file,inpcrd_file,amber_pdb_file,gaff_input_file,frcmod_file,rec_prmtop_file,rec_log_file,rec_inpcrd_file,rec_amber_pdb_file );
}